#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
using namespace std;
typedef long double ld;

int main(){
    ios::sync_with_stdio(false);
    cout.precision(14);
    cout<<fixed;

    // Read gravity and segment descriptions
    int n; ld g; cin>>n>>g;
    vector<pair<ld,ld>> seg(n+1);
    for (int i=0; i<n; i++) cin>>seg[i].first>>seg[i].second, seg[i].second*=M_PI/180.L;

    // Compute velocities using integration
    for (int src=0; src<n; src++){
        ld vel=0.L;
        for (int i=src; i<n; i++){
            // v = vel + g*t*cos(theta)
            // d = integrate(v, t)
            // d = vel*t + 1/2g*t^2*cos(theta)
            // t^2 (g*cos(theta)) + t (2*vel) - 2d = 0
            // t = (-2*vel +- sqrt(4*vel^2 + 8*g*cos(theta)*d)) / (2*g*cos(theta))
            // sub back in
            // v = vel + g*t*cos(theta)
            // v = vel + (-vel +- sqrt(vel^2 + 2*g*cos(theta)*d))
            vel += (-vel + sqrtl(vel*vel + 2*g*cosl(seg[i].second)*seg[i].first));
        }
        cout<<vel<<endl;
    }
}
