#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
using namespace std;
typedef long double ld;

int main(){
    ios::sync_with_stdio(false);
    cout.precision(14);
    cout<<fixed;

    // Read gravity and segment descriptions
    int n; ld g; cin>>n>>g;
    vector<pair<ld,ld>> seg(n+1);
    for (int i=0; i<n; i++) cin>>seg[i].first>>seg[i].second;

    // Convert distances to absolute heights
    for (int i=n; i--;) (seg[i].first*=cosl(seg[i].second*M_PI/180.L))+=seg[i+1].first;

    // Calculate potential energy = kinetic energy, print sqrt(x/2) for velocity
    for (int i=0; i<n; i++){
        ld v=sqrtl(g*seg[i].first*2);
        cout<<v<<"\n";
    }
}
