#include <algorithm>
#include <iostream>
#include <cassert>
#include <vector>
#include <cmath>
#include <set>
using namespace std;
typedef long long ll;
#define circle 360000

struct Place{
    ll dist;
    ll angle;
} place[50000];

struct Taxi{
    ll min_dist;
    ll max_angle;
} taxi[200];

int prev_it(multiset<int> const &s,int iv){
    auto i=s.find(iv);
    return (i==s.begin()? *s.rbegin(): *--i);
}
int next_it(multiset<int> const &s,int iv){
    auto i=s.find(iv);
    return (s.end()==++i? *s.begin(): *i);
}

int main(){
    int t,n; cin>>t>>n;
    for (int i=0; i<t; i++){
        cin>>taxi[i].min_dist>>taxi[i].max_angle;
    }
    for (int i=1; i<n; i++){
        cin>>place[i].dist>>place[i].angle;
        place[i].dist+=place[i-1].dist;
        (place[i].angle+=place[i-1].angle+circle)%=circle;
    }

    static int need[50123];
    for (int i=0; i+1<n; i++)
        need[i]=n+1;

    // Persistent variables we'll use for the DP
    vector<int> _a(t,n),_b(t,n);
    multiset<int> _values[200],_angles[200],_dangles[200];

    for (int j=n; j--;){
        for (int i=t; i--;){
            auto &a=_a[i],&b=_b[i];
            auto &values=_values[i],&angles=_angles[i],&dangles=_dangles[i];

            // insert new angle
            if (j+1<n){
                angles.insert(place[j+1].angle);
                if (angles.size()==1){
                    dangles={0};
                }else{
                    int u=prev_it(angles,place[j+1].angle);
                    int v=next_it(angles,place[j+1].angle);
                    dangles.erase(dangles.find((v-u+circle)%circle));
                    dangles.insert((place[j+1].angle-u+circle)%circle);
                    dangles.insert((v-place[j+1].angle+circle)%circle);
                }
            }
            // move left bound
            while (a-1>j and place[a-1].dist-place[j].dist>=taxi[i].min_dist){
                --a;
                values.insert(need[a]);
            }
            // move right bound
            while (b>a and (circle-*dangles.rbegin())%circle>taxi[i].max_angle){
                --b;

                // delete angle
                if (angles.size()==1){
                    dangles.clear();
                }else{
                    int u=prev_it(angles,place[b].angle);
                    int v=next_it(angles,place[b].angle);
                    dangles.erase(dangles.find((place[b].angle-u+circle)%circle));
                    dangles.erase(dangles.find((v-place[b].angle+circle)%circle));
                    dangles.insert((v-u+circle)%circle);
                }
                angles.erase(angles.find(place[b].angle));

                // remove value from set
                values.erase(values.find(need[b]));
            }

            if (not values.empty()){
                need[j]=min(need[j],1+*values.begin());
            }
        }
    }

    if (need[0]<=n){
        cout<<need[0]<<endl;
    }else{
        cout<<"IMPOSSIBLE\n";
    }
}
