#include <algorithm>
#include <iostream>
#include <cassert>
#include <set>
using namespace std;
typedef long long ll;

multiset<ll> angles, diffs;
struct Evt {ll dist,angle;} v[50123], q[212];

ll fix_angle(ll x){
    if (x<0) x=360000-((-x)%360000);
    return x%360000;
}

ll heading_range(){
    if (diffs.empty()) return 0;
    ll res=360000-max(*diffs.rbegin(),*angles.begin()-*angles.rbegin()+360000);
    assert(0<=res and res<360000);
    return res;
}
void add_angle(ll x){
    x=fix_angle(x);
//    cerr<<"adding "<<x<<endl;
    auto it=angles.insert(x);
    auto jt=it,kt=it; ++jt; if (it!=angles.begin()) --kt;
    if (it!=angles.begin() and jt!=angles.end()){
        diffs.erase(diffs.find(*jt-*kt));
    }
    if (jt!=angles.end())   {diffs.insert(*jt-*it); }
    if (it!=angles.begin()) {diffs.insert(*it-*kt); }
//    cerr<<"added "<<x<<": "<<heading_range()<<endl;
}
void remove_angle(ll x){
    x=fix_angle(x);
//    cerr<<"remove "<<x<<endl;
    auto it=angles.find(x); assert(it!=angles.end());
    auto jt=it,kt=it; ++jt; if (it!=angles.begin()) --kt;
    if (jt!=angles.end())   diffs.erase(diffs.find(*jt-*it));
    if (it!=angles.begin()) diffs.erase(diffs.find(*it-*kt));
    if (jt!=angles.end() and it!=angles.begin()) diffs.insert(*jt-*kt);
    angles.erase(it);
//    cerr<<"remove "<<x<<": "<<heading_range()<<endl;
}

int near[50123][212];
int fear[50123][212];

int rmq[50000+(1<<16)][17];
int get_least(int s,int t){
    int rng=0; while (t-(1<<rng)>s+(1<<rng)) ++rng;
//    cerr<<"query is "<<s<<".."<<s+(1<<rng)<<" and "<<t-(1<<rng)<<".."<<t<<"\t";
//    cerr<<" @ "<<rmq[s][rng]<<" | "<<rmq[t-(1<<rng)][rng]<<endl;
    return min(rmq[s][rng],rmq[t-(1<<rng)][rng]);
}

int main(){
    int t,n; cin>>t>>n;
    for (int i=t; i--;) cin>>q[i].dist>>q[i].angle;
    for (int i=1; i<n; i++) {cin>>v[i].dist>>v[i].angle; v[i].angle=fix_angle(v[i].angle+v[i-1].angle);}
    v[n].angle=v[n+1].angle=v[n-1].angle;
    v[0].angle=v[1].angle;

    for (int i=t; i--;){
        angles.clear(); diffs.clear();
        near[0][i]=fear[0][i]=0;
        ll cdist=0;
        for (int j=0; j<n; j++){
//            cerr<<"looking at "<<v[j].dist<<" "<<v[j].angle<<endl;
//            angles.clear(); diffs.clear();
//            near[j][i]=j; fear[j][i]=j;
//            cdist=0;

            if (j) near[j][i]=near[j-1][i], cdist-=v[j-1].dist;
            if (j) fear[j][i]=fear[j-1][i], remove_angle(v[j-1].angle);

            while (near[j][i]<=n+1 and cdist<q[i].dist) cdist+=v[near[j][i]++].dist;
            while (fear[j][i]<=n+1 and heading_range()<=q[i].angle) add_angle(v[fear[j][i]++].angle);
//            cerr<<i<<" "<<j<<": "<<near[j][i]<<" "<<fear[j][i]<<endl;

/*
            int s=n,t=j;
            angles.clear();
            diffs.clear();
            for (int k=j; k<n; k++){
                cdist+=v[k].dist;
                add_angle(v[k].angle);
//                cerr<<"Heading range for "<<j<<"..."<<k<<" is "<<heading_range();
                if (cdist>=q[i].dist and heading_range()<=q[i].angle){
//                    cerr<<" => good ("<<i<<")";
                    s=min(s,k+1);
                    t=max(t,k+2);
                }
//                cerr<<endl;
            }
            near[j][i]=s;
            fear[j][i]=t;
//            cerr<<i<<" "<<j<<": "<<near[j][i]<<" "<<fear[j][i]<<" with "<<q[i].dist<<" @ "<<cdist<<" -> "<<cdist-v[near[j][i]-1].dist<<endl;
*/
        }
//        cerr<<endl<<endl;
    }

    for (int i=n; i--;){
        rmq[i][0]=n+5;
        for (int j=t; j--;){
            int s=near[i][j],t=fear[i][j];
//            if (q[j].dist<=1000) cerr<<"  query for "<<s<<"..."<<t<<"           | "<<q[j].dist<<" "<<q[j].angle<<endl;
            if (s<t) rmq[i][0]=min(rmq[i][0],1+get_least(s,t));
        }
        for (int j=0; j+1<17; j++){
            rmq[i][j+1]=min(rmq[i][j],rmq[i+(1<<j)][j]);
        }
//        cerr<<"answer["<<i<<"] = "<<rmq[i][0]<<endl;
    }

    if (rmq[0][0]==n+5)
        cout<<"IMPOSSIBLE\n";
    else
        cout<<rmq[0][0]<<endl;
}
