import java.util.Scanner;
import java.util.TreeMap;
import java.util.TreeSet;

/**
 * TODO: Insert description here. (generated by salewijnse)
 */
public class Sander {
  static class Transport {
    Transport(String name, int d, int a) {
      this.name = name;
      this.d = d;
      this.a = a;
    }

    String name;
    int d;
    int a;
  }

  static class Poi {
    Poi(int d, int a) {
      this.d = d;
      this.a = a;
    }

    int d;
    int a;
  }

  public static void main(String[] args) {
    Scanner scanner = new Scanner(System.in);

    int t = scanner.nextInt();
    int n = scanner.nextInt();
    final int c = 360;

    //System.out.println(String.format("t=%d, n=%d", t, n));

    Transport[] ts = new Transport[t];

    for (int i=0; i<t; i++) {
      ts[i] = new Transport("undef", scanner.nextInt(), scanner.nextInt());
      System.out.println(String.format("ts[%d]=Transport(%s, %d, %d)", i, ts[i].name, ts[i].d, ts[i].a));
    }

    Poi[] ps = new Poi[n];
    ps[0] = new Poi(0, 0);

    for (int i=1; i<n; i++) {
      ps[i] = new Poi(scanner.nextInt(), scanner.nextInt());
      ps[i].a = (ps[i].a + ps[i-1].a + 360) % c;
      System.out.println(String.format("ps[%d]=Poi(%d, %d)", i, ps[i].d, ps[i].a));
    }


    /**
     * minv[j][i] minimal index m for which [i,m] is valid for transportation j
     * Depends on ts[j].d and ps.d
     */
    int[][] minv = new int[t][n];

    for (int j=0; j<t; j++) {
      int sum = 0;
      int end = 0;
      for (int i=0; i<n; i++) {
        while (end < n && sum < ts[j].d) {
          sum += ps[end++].d;
        }
        minv[j][i] = sum < ts[j].d ? -1 : end;
        System.out.println(String.format("minv[%d][%d]=%d", j, i, minv[j][i]));

        sum -= ps[i].d;
      }
    }

    // Start verify minv[][]
    for (int j=0; j<t; j++) {
      for (int i=0; i<n; i++) {
        int sum = 0;
        if (minv[j][i] < 0) {
          for (int ii=i; ii<n; ii++) {
            sum+=ps[ii].d;
          }
          if (sum>=ts[j].d) {
            throw new IllegalStateException("nope, it can reach something");
          }
        } else {
          for (int ii=i; ii<minv[j][i]; ii++) {
            sum+=ps[ii].d;
          }
          if (sum<ts[j].d) {
            throw new IllegalStateException("nope, it is too short");
          }
          if (sum - ps[minv[j][i]-1].d >= ts[j].d) {
            throw new IllegalStateException("nope, it is not minimal");
          }
        }
      }
    }
    // End verify

    /**
     * maxv[j][i] maximal index m for which [i,m] is valid for transportation j
     * Depends on ts[j].a and ps.a
     */
    int[][] maxv = new int[t][n];

    for (int j=0; j<t; j++) {
      // Contains all the angles in current leg
      TreeMap<Integer, Integer> amm = new TreeMap<Integer, Integer>();
      // Contains all the angle gaps in current leg
      TreeSet<Integer> gaps = new TreeSet<Integer>();
      gaps.add(c);

      int end = 0;
      for (int i=0; i<n; i++) {
        while (end < n && c - gaps.last() <= ts[j].a) {
          int a = ps[end++].a;
          if(amm.containsKey(a)) {
            // gaps don't change
            amm.put(a, amm.get(a)+1);
          } else {
            amm.put(a, 1);
            if (amm.size() == 1) {
              continue;
            }

            // split gap
            int high;
            if (amm.higherKey(a) == null) {
              high = amm.firstKey() + c;
            } else {
              high = amm.higherKey(a);
            }

            int low;
            if (amm.lowerKey(a) == null) {
              low = amm.lastKey() - c;
            } else {
              low = amm.lowerKey(a);
            }

            gaps.remove(high-low);
            gaps.add(high-a);
            gaps.add(a-low);
          }
        }

        maxv[j][i] = end - 1;
        System.out.println(String.format("maxv[%d][%d]=%d", j, i, maxv[j][i]));

        // remove first angle
        int a = ps[i].a;
        if(amm.get(a) > 1) {
          // gaps don't change
          amm.put(a, amm.get(a)-1);
        } else {
          if (amm.size() <= 2) {
            gaps.clear();
            gaps.add(c);
          } else {
            // merge gaps
            int high;
            if (amm.higherKey(a) == null) {
              high = amm.firstKey() + c;
            } else {
              high = amm.higherKey(a);
            }

            int low;
            if (amm.lowerKey(a) == null) {
              low = amm.lastKey() - c;
            } else {
              low = amm.lowerKey(a);
            }

            gaps.add(high-low);
            gaps.remove(high-a);
            gaps.remove(a-low);
          }
          amm.remove(a);
        }
      }
    }

    // Start verify maxv[][]
    for (int j=0; j<t; j++) {
      for (int i=0; i<n; i++) {
        TreeSet<Integer> angles = new TreeSet<Integer>();

        for (int ii=i; ii<maxv[j][i]; ii++) {
          angles.add(ps[ii].a);
        }


        if (c-maxgap(angles, c)>ts[j].a) {
          throw new IllegalStateException("nope, direction varies too much");
        }
        if (c-maxv[j][i]>=n) {
          continue;
        }
        angles.add(ps[maxv[j][i]].a);
        if (maxgap(angles, c)<=ts[j].a) {
          throw new IllegalStateException("nope, it is not maximal");
        }
      }
    }
    // End verify maxv[][]

    int[] s = new int[n]; // number of cab switches required for journey
    for (int i=0; i<n; i++) {
      s[i] = 2*n;
    }
    s[n-1] = 0;

    STNode root = constructSegmentTree(s, 0, n-1);
    updateValueAtIndex(root, new MinEntry(n-1, 0));

    for (int i=n-1; i>=0; i--) {
      for (int j=0; j<t; j++) {
        MinEntry minEntry = getMin(root, minv[j][i], maxv[j][i]);

        // Start verify RMQ
        if (minEntry.argmin != argminrange(s, minv[j][i], maxv[j][i])) {
          throw new IllegalStateException("RMQ not correct!");
        }
        // End verify

        if (minEntry.argmin < 0) {
          continue;
        }
        if (minEntry.min + 1 < s[i]) {
          s[i] = minEntry.min + 1;
          System.out.println("s[" + i + "] = " + s[i] + " with " + j + ": " + minv[j][i] + "..." + maxv[j][i]);
          updateValueAtIndex(root, new MinEntry(i, s[i]));
        }
      }
      System.out.println("s[" + i + "] = " + s[i]);
    }

    if (s[0]==2*n) {
      System.out.println("IMPOSSIBLE");
    } else {
      System.out.println(s[0]);
    }
  }

  static class STNode {
    int leftIndex;
    int rightIndex;
    MinEntry minimum;
    STNode leftNode;
    STNode rightNode;
  }

  static class MinEntry {
    MinEntry(int min, int argmin) {
      this.min = min;
      this.argmin = argmin;
    }
    int min;
    int argmin;
  }

  static MinEntry min(MinEntry a, MinEntry b) {
    if (a.min < b.min) {
      return a;
    } else {
      return b;
    }
  }

  static STNode constructSegmentTree(int[] A, int l, int r) {
    if (l == r) {
        STNode node = new STNode();
        node.leftIndex = l;
        node.rightIndex = r;
        node.minimum = new MinEntry(A[l], l);
        return node;
    }
    int mid = (l + r) / 2;
    STNode leftNode = constructSegmentTree(A, l, mid);
    STNode rightNode = constructSegmentTree(A, mid+1, r);
    STNode root = new STNode();
    root.leftIndex = leftNode.leftIndex;
    root.rightIndex = rightNode.rightIndex;
    root.minimum = min(leftNode.minimum, rightNode.minimum);
    root.leftNode = leftNode;
    root.rightNode = rightNode;
    return root;
  }

  static MinEntry getMin(STNode root, int l, int r) {
    if (l > r) {
      return new MinEntry(1000000000, -1);
    }
    if (root.leftIndex >= l && root.rightIndex <= r) {
        return root.minimum;
    }
    if (root.rightIndex < l || root.leftIndex > r) {
        return new MinEntry(1000000000, -1);
    }
    return min(getMin(root.leftNode, l, r), getMin(root.rightNode, l, r));
  }

  static void updateValueAtIndex(STNode root, MinEntry min) {
      if(root.leftIndex==root.rightIndex && min.argmin == root.leftIndex) {
          // We actually reached to the leaf node to be updated
          root.minimum = min;
          return;
      }
      int mid = (root.leftIndex + root.rightIndex) / 2;
      if (min.argmin <= mid) {
          updateValueAtIndex(root.leftNode, min);
      } else {
          updateValueAtIndex(root.rightNode, min);
      }
      root.minimum = min(root.minimum, min);
  }

  // Only for verification
  static int argminrange(int[] array, int start, int end) {
    if (end < start) {
      return -1;
    }
    int argmin = start;
    int min = array[start];
    for (int i=start; i<=end; i++) {
      if (array[i] < min) {
        min = array[i];
        argmin = i;
      }
    }
    return argmin;
  }

  // Only for verification
  static int maxgap(TreeSet<Integer> angles, int c) {
    if (angles.size() < 2) {
      return c;
    }
    int maxgap = 0;
    int lastAngle = angles.last();
    for (int aa : angles) {
      int gap = aa - lastAngle;
      if (gap < 0) gap += c;
      if (gap > maxgap) {
        maxgap = gap;
      }
      //System.out.println(String.format("diff between %d, %d is %d", lastAngle, aa, gap));
      lastAngle = aa;
    }
    return maxgap;
  }
}


