#!/usr/bin/env python3
from sys import stdin
from fractions import Fraction

lut = {}
def encode(frac):
    global lut
    rep = str(frac)
    if rep not in lut:
        lut[rep] = len(lut)
    return lut[rep]

def modpow(a,b,m):
    if b <= 1: return a%m if b==1 else 1
    return (modpow((a*a)%m,b//2,m) * modpow(a,b%2,m)) % m

m,n = map(int, stdin.readline().split(' '))
nee = list(map(int, stdin.readline().split(' ')))
hay = list(map(int, stdin.readline().split(' ')))

orig = hay[:]
nee = list(map(lambda i: encode(Fraction(nee[i]-nee[i-1],nee[i]-nee[i-2])), range(2,len(nee))))
hay = list(map(lambda i: encode(Fraction(hay[i]-hay[i-1],hay[i]-hay[i-2])), range(2,len(hay))))

h1 = 0
h2 = 0
h3 = 0
for i in nee:
    h1 += i
    h2 = (h2 *   7 +   i) % (2**31 - 1)
    h3 = (h3 * 555 + 7*i) % (2**27 - 1)

lm2 = modpow(  7,len(nee),2**31-1)
lm3 = modpow(555,len(nee),2**27-1)

h1b = 0
h2b = 0
h3b = 0
res = set()
for i in range(-1, len(hay)):
    if i >= 0:
        h1b += hay[i]
        h2b = (h2b *   7 +   hay[i]) % (2**31 - 1)
        h3b = (h3b * 555 + 7*hay[i]) % (2**27 - 1)

    if i >= len(nee):
        h1b -= hay[i-len(nee)]
        h2b = (h2b -     hay[i-len(nee)]*lm2 + (2**31-1)  ) % (2**31-1)
        h3b = (h3b - 7 * hay[i-len(nee)]*lm3 + (2**27-1)*7) % (2**27-1)

    if i+1 >= len(nee):
        if h1 == h1b and h2 == h2b and h3 == h3b:
            res.add(orig[i-len(nee)+2]-orig[i-len(nee)+1])

print(len(res))
print(' '.join(map(str, sorted(res))))
