#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
using namespace std;
typedef long long ll;

ll p[1000000];
ll x[1000000];

ll gcd(ll a,ll b){return b?gcd(b,a%b):a;}

struct Fraction{
    ll num;
    ll den;

    void cancel(){
        if (num==0) den=1;
        ll g=max(1ll,gcd(abs(num),abs(den)));
        num/=g;
        den/=g;
        if (den<0) num=-num,den=-den;
    }

    Fraction(ll n,ll d):num(n),den(d){
        cancel();
    }

    bool operator==(Fraction const &a)const{return num==a.num and den==a.den;}
    bool operator!=(Fraction const &a)const{return !(*this==a);}
    bool operator<(Fraction const &a)const{return num*a.den<a.num*den;}
};

vector<Fraction> needle,haystack;
vector<int> kmp;

int main(){
    int n,m; cin>>n>>m;
    if (n<=1){
        cout<<m-1<<endl;
        return 0;
    }

    for (int i=0; i<n; i++) cin>>p[i];
    for (int i=0; i<m; i++) cin>>x[i];

    for (int i=2; i<n; i++) needle.emplace_back(p[i]-p[i-1],p[i-1]-p[i-2]); // cerr<<" "<<needle[i-2].num<<"/"<<needle[i-2].den; cerr<<endl;
    for (int i=2; i<m; i++) haystack.emplace_back(x[i]-x[i-1],x[i-1]-x[i-2]); // cerr<<" "<<haystack[i-2].num<<"/"<<haystack[i-2].den; cerr<<endl;
    n-=2;
    m-=2;

    kmp.push_back(0);
    kmp.push_back(0);
    for (int i=2; i<=n; i++){
        kmp.push_back(kmp.back());
        while (kmp[i] and needle[kmp[i]]!=needle[i-1]) kmp[i]=kmp[kmp[i]];
        if (kmp[i]+1<i and needle[kmp[i]]==needle[i-1]) ++kmp[i];
    }

    set<ll> res;
    for (int i=0,s=0; i<m; i++){
        while (s and needle[s]!=haystack[i]) s=kmp[s];
        if (needle[s]==haystack[i]) ++s;
        if (s==needle.size()) s=kmp[s], res.insert(x[i+2]-x[i+1]);
    }

    cout<<res.size()<<endl;
    bool printed=false;
    for (auto i: res) cout<<(printed?" ":"")<<i, printed=true;
    cout<<endl;
}
