#include <iostream>
#include <sstream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cstdio>
#include <cctype>
#include <cstring>

using namespace std;

const string hardcons = "bcdgknpt";

const int maxlen = 10010;

const char nearest_hardcons(char c)
{
	if ( isupper(c) ) c = tolower(c);
	if ( c<hardcons[0] ) return hardcons[0];
	int i;
	for(i=hardcons.length()-1; i>0 && hardcons[i]>=c; i--);
	if ( i==hardcons.length()-1 ) return hardcons[i];
	if ( c-hardcons[i]<=hardcons[i+1]-c ) return hardcons[i];
	return hardcons[i+1];
}

char replace(char a, char b)
{
	return isupper(a) ? toupper(b) : b;
}

int main()
{
	string word, res;

	while ( cin >> word ) {
		istringstream ss(word);

		char syl[maxlen], c;
		ss.getline(syl,maxlen,'-');
		c = nearest_hardcons(syl[0]);
		syl[0] = replace(syl[0],c);
		res += syl;
		string hc1;
		for(int i=0; i<strlen(syl); i++)
			if ( hardcons.find(tolower(syl[i]))!=string::npos )
				hc1 += tolower(syl[i]);

		while ( ss.getline(syl,maxlen,'-') ) {
			for(int i=0; i<strlen(syl); i++) {
				if ( hardcons.find(tolower(syl[i]))!=string::npos &&
					 hc1.find(tolower(syl[i]))==string::npos )
					syl[i] = replace(syl[i],c);
			}
			res += syl;
		}

		/* FIXME: the problem statement is inconsistent with the
		 * examples "dog" -> "dogoh" and "Hip" -> Hipah".
		 */
		switch ( tolower(res.back()) ) {
		case 'b':
		case 'c':
		case 'd':
		case 'g':
			res += "ah";
			break;
		case 'k':
		case 'n':
		case 'p':
			res += "oh";
			break;
		case 't':
			res += "uh";
			break;
		}

		res += ' ';
	}

	res.pop_back();
	cout << res << endl;

	return 0;
}
