#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;
typedef double ld;

pair<int,int> v[1000000];
ld phase[2][1000000];

ld angle(int a,int b){
    if (a==-1 or b==-1 or v[b].second<=v[a].second) return M_PI/2.;
    return atan2(abs(v[a].first-v[b].first), v[b].second-v[a].second);
}

void solve(int n,ld *res){
  vector<int> all={-1};
  for (int i=0; i<n; i++){
    while (all.size()>=2 and angle(i,all[all.size()-2])<=angle(i,all.back())) all.pop_back();
    res[i]=angle(i,all.back());
    all.push_back(i);
  }
}

int main(){
    int n; cin>>n;
    for (int i=0; i<n; i++) cin>>v[i].first>>v[i].second;
    for (int i=2; i--; reverse(v,v+n)) solve(n,phase[i]);
    reverse(phase[0],phase[0]+n);
    cout.precision(9);
    cout<<fixed;
    for (int i=0; i<n; i++)
      cout<<(phase[0][i]+phase[1][i])*12./M_PI<<endl;
}
