#include <algorithm>
#include <cassert>
#include <cstdint>
#include <cstdio>
using namespace std;

/*
    utility to take an input specification and blur it with an NxN box
    filter, on the assumption it was generated without the blur step
    already done
*/

int64_t cell[2001][2001];
bool seen[2001][2001];
int n,r,c;

void dfs(int i,int j){
    seen[i][j]=true;
    for (int di=-1,dj=0,z=4; z--; swap(di,dj*=-1))
        if (i+di>=0 and j+dj>=0 and i+di<r and j+dj<c and cell[i+di][j+dj] and not seen[i+di][j+dj])
            dfs(i+di,j+dj);
}

int main(){
    scanf("%d %d %d",&n,&r,&c);
    printf("%d %d %d\n",n,r,c);

    for (int i=0; i<r; i++)
        for (int j=0; j<c; j++)
            scanf("%llx",&cell[i][j]);

    if (true){
        int regions=0;
        for (int i=r; i--;)
            for (int j=c; j--;)
                if (cell[i][j] and not seen[i][j])
                    dfs(i,j), ++regions;
        fprintf(stderr, "%d\n",regions);
    }

    for (int i=0; i<2000; i++)
        for (int j=0; j<2000; j++){
            cell[i+1][j]+=cell[i][j];
            cell[i][j+1]+=cell[i][j];
            cell[i+1][j+1]-=cell[i][j];
        }

    for (int i=n/2; i<r+n/2; i++){
        for (int j=n/2; j<c+n/2; j++){
            assert(cell[i][j]>=cell[i-1][j]+cell[i][j-1]-cell[i-1][j-1]);

            int64_t avg=cell[i][j];

            if (i>=n) avg-=cell[i-n][j];
            if (j>=n) avg-=cell[i][j-n];
            if (i>=n and j>=n) avg+=cell[i-n][j-n];

            avg/=(n*n);
            printf("%04llX%c",avg,(j+1==c+n/2?'\n':' '));
        }
    }
}
