#include <algorithm>
#include <cassert>
#include <cstdint>
#include <cstdio>
#include <queue>
#include <map>
using namespace std;

int64_t cell[2001][2001];
int rows,cols;

int64_t undivide(int64_t v,int64_t n){
    int64_t r=v*n;
    if (r%0xFFFFll) r+=0xFFFFll-(r%0xFFFFll);
    assert(r/n==v);
    return r;
}

void paint(int r,int c){
    queue<pair<int,int>> todo; todo.push({r,c}); cell[r][c]=0;
    while (not todo.empty()){
        r=todo.front().first,c=todo.front().second;todo.pop();
        for (int dr=0,dc=1,z=4; z--; swap(dr,dc*=-1))
            if (r+dr>=0 and c+dc>=0 and r+dr<rows and c+dc<cols and cell[r+dr][c+dc])
                cell[r+dr][c+dc]=0, todo.push({r+dr,c+dc});
    }
}

int main(){
    int n,r,c; scanf("%d%d%d",&n,&r,&c); rows=r,cols=c;
    int res=0;

    for (int i=n/2; i<r+n/2; i++)
        for (int j=n/2; j<c+n/2; j++){
            scanf("%llx",&cell[i][j]);
            cell[i][j]=undivide(cell[i][j],n*n);

            if (i>=n) cell[i][j]+=cell[i-n][j];
            if (j>=n) cell[i][j]+=cell[i][j-n];
            if (i>=n and j>=n) cell[i][j]-=cell[i-n][j-n];
        }

    for (int i=1500; i--;)
        for (int j=1500; j--;){
            if (i) cell[i][j]-=cell[i-1][j];
            if (j) cell[i][j]-=cell[i][j-1];
            if (i and j) cell[i][j]+=cell[i-1][j-1];
        }

/*
    for (int i=0; i<r; i++, puts(""))
        for (int j=0; j<c; j++)
            printf("%04llX ", cell[i][j]);
*/

    for (int i=r; i--;)
        for (int j=c; j--;)
            if (cell[i][j]) paint(i,j), ++res;

    printf("%d\n",res);
}
