#!/bin/bash

set -o pipefail

name="$1"
if [ -z "$name" ]
  then
    echo "No name specified" >&2
    exit 1
  fi

if [ -e ./problems/"$name" ]
  then
    printf 'A problem called "%s" already exists\n' "$name" >&2
    exit 1
  fi

mkdir -p ./problems/"$name"/submissions/{accepted,wrong_answer,time_limit_exceeded}
mkdir -p ./problems/"$name"/data/{sample,secret}
mkdir -p ./problems/"$name"/problem_statement

touch ./problems/"$name"/problem_statement/problem.en.tex
